"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var index_1 = require("./index");
var CoreModule = (function () {
    function CoreModule() {
    }
    return CoreModule;
}());
CoreModule = __decorate([
    core_1.NgModule({
        imports: [index_1.AppConfig, http_1.HttpModule],
        declarations: [],
        providers: [index_1.AppConfig],
        exports: [index_1.LoaderComponent]
    })
], CoreModule);
exports.CoreModule = CoreModule;

"use strict";
exports.__esModule = true;
var http_1 = require("@angular/http");
exports.contentHeaders = new http_1.Headers();
exports.contentHeaders.append('Accept', 'application/json');
exports.contentHeaders.append('Content-Type', 'application/json');

"use strict";
exports.__esModule = true;
var http_interceptor_1 = require("./http.interceptor");
function httpFactory(xhrBackend, requestOptions, localStorageService, loaderService) {
    return new http_interceptor_1.InterceptedHttp(xhrBackend, requestOptions, localStorageService, loaderService);
}
exports.httpFactory = httpFactory;

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var InterceptedHttp = (function (_super) {
    __extends(InterceptedHttp, _super);
    function InterceptedHttp(backend, defaultOptions, localStorageService, loaderService) {
        var _this = _super.call(this, backend, defaultOptions) || this;
        _this.localStorageService = localStorageService;
        _this.loaderService = loaderService;
        return _this;
    }
    InterceptedHttp.prototype.get = function (url, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.get.call(this, url, this.getRequestOptionArgs(options))["do"](function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })["finally"](function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.post = function (url, body, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.post.call(this, url, body, this.getRequestOptionArgs(options))["do"](function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })["finally"](function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.put = function (url, body, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.put.call(this, url, body, this.getRequestOptionArgs(options))["do"](function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })["finally"](function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype["delete"] = function (url, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype["delete"].call(this, url, this.getRequestOptionArgs(options))["do"](function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })["finally"](function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.getRequestOptionArgs = function (options) {
        if (options == null) {
            options = new http_1.RequestOptions();
        }
        if (options.headers == null) {
            options.headers = new http_1.Headers();
        }
        options.headers.append('Content-Type', 'application/json');
        if (!options.withCredentials)
            this.createAuthorizationHeader(options.headers);
        return options;
    };
    InterceptedHttp.prototype.createAuthorizationHeader = function (headers) {
        if (this.localStorageService.get('id_token') != null) {
            headers.append('Authorization', this.localStorageService.get('id_token'));
        }
    };
    InterceptedHttp.prototype.onCatch = function (error) {
        //return Observable.throw(error);
        return error;
    };
    InterceptedHttp.prototype.onSuccess = function (res) {
        console.log('Request successful');
    };
    InterceptedHttp.prototype.onError = function (res) {
        console.log('Error, status code: ' + res.status);
    };
    InterceptedHttp.prototype.onEnd = function () {
        this.hideLoader();
    };
    InterceptedHttp.prototype.showLoader = function () {
        this.loaderService.show();
    };
    InterceptedHttp.prototype.hideLoader = function () {
        this.loaderService.hide();
    };
    return InterceptedHttp;
}(http_1.Http));
InterceptedHttp = __decorate([
    core_1.Injectable()
], InterceptedHttp);
exports.InterceptedHttp = InterceptedHttp;

"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
exports.__esModule = true;
__export(require("./config-service/app.config"));
__export(require("./setting"));
__export(require("./core.module"));
__export(require("./headers"));
__export(require("./loader/loader.service"));
var loader_component_1 = require("./loader/loader.component");
exports.LoaderComponent = loader_component_1.LoaderComponent;
var http_factory_1 = require("./http.factory");
exports.httpFactory = http_factory_1.httpFactory;
__export(require("./extensions/array.extensions"));
__export(require("./extensions/string.extensions"));

"use strict";
exports.__esModule = true;
var Setting = (function () {
    function Setting(key, value) {
        this.key = key;
        this.value = value;
    }
    return Setting;
}());
exports.Setting = Setting;

"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
var core_1 = require("@angular/core");
var Rx_1 = require("rxjs/Rx");
var setting_1 = require("../setting");
var AppConfig = (function () {
    function AppConfig(http) {
        this.http = http;
        this.paths = [];
        this.config = [];
        this.env = null;
        this.subject = new Rx_1.Subject();
        this.initialized = this.subject.asObservable();
    }
    AppConfig.prototype.getPresentationConfigs = function () {
        return this.config.filter(function (x) { return x.key.toLowerCase().endsWith("config"); });
    };
    AppConfig.prototype.get = function (key) {
        var setting = this.config.filter(function (x) { return x.key.toLowerCase() == key.toLowerCase(); });
        return setting.length > 0 ? setting[0].value : null;
    };
    AppConfig.prototype.getEnv = function (key) {
        return this.env[key];
    };
    AppConfig.prototype.addNavigationItems = function (applicationName, paths) {
        var _loop_1 = function (path) {
            if (this_1.paths.filter(function (x) { return x.value.name == path.name; }).length == 0) {
                this_1.paths.push(new setting_1.Setting(applicationName, { name: path.name, route: path.route }));
            }
        };
        var this_1 = this;
        for (var _i = 0, paths_1 = paths; _i < paths_1.length; _i++) {
            var path = paths_1[_i];
            _loop_1(path);
        }
    };
    AppConfig.prototype.fetchNavigationItems = function (applicationName) {
        return this.paths.filter(function (x) { return x.key === applicationName; }).map(function (x) { return new setting_1.Setting(x.value.name, x.value.route); });
    };
    AppConfig.prototype.initialize = function (settings, env) {
        this.config = this.config.concat(settings);
        this.env = env;
        this.subject.next(true);
    };
    return AppConfig;
}());
AppConfig = __decorate([
    core_1.Injectable()
], AppConfig);
exports.AppConfig = AppConfig;

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
if (!Array.prototype.add) {
    Array.prototype.add = function (item) {
        this.push(item);
    };
}
if (!Array.prototype.addRange) {
    Array.prototype.addRange = function (items) {
        var _this = this;
        items.forEach(function (x) { return _this.push(x); });
    };
}
if (!Array.prototype.remove) {
    Array.prototype.remove = function (item) {
        var index = this.indexOf(item);
        this.splice(index, 0);
        return index != -1;
    };
}
if (!Array.prototype.where) {
    Array.prototype.where = function (func) {
        var items = this.filter(func);
        return items;
    };
}
if (!Array.prototype.orderBy) {
    Array.prototype.orderBy = function (propertyExpression) {
        var result = Array();
        var compareFunction = function (item1, item2) {
            if (propertyExpression(item1) > propertyExpression(item2))
                return 1;
            if (propertyExpression(item2) > propertyExpression(item1))
                return -1;
            return 0;
        };
        for (var i = 0; i < this.length; i++) {
            return this.sort(compareFunction);
        }
        return result;
    };
}
if (!Array.prototype.orderByDescending) {
    Array.prototype.orderByDescending = function (propertyExpression) {
        var result = Array();
        var compareFunction = function (item1, item2) {
            if (propertyExpression(item1) > propertyExpression(item2))
                return -1;
            if (propertyExpression(item2) > propertyExpression(item1))
                return 1;
            return 0;
        };
        for (var i = 0; i < this.length; i++) {
            return this.sort(compareFunction);
        }
        return result;
    };
}
if (!Array.prototype.single) {
    Array.prototype.single = function (func) {
        if (func === void 0) { func = null; }
        var items = this;
        if (func != null)
            items = this.filter(func);
        if (items.length > 1)
            throw new SequenceContainsMoreThanOneElementException();
        if (items.length == 0)
            throw new SequenceDoesNotContainException();
        return items[0];
    };
}
if (!Array.prototype.singleOrDefault) {
    Array.prototype.singleOrDefault = function (func) {
        if (func === void 0) { func = null; }
        var items = this;
        if (func != null)
            items = this.filter(func);
        if (items.length > 1)
            throw new SequenceContainsMoreThanOneElementException();
        if (items.length == 0)
            return null;
        return items[0];
    };
}
if (!Array.prototype.first) {
    Array.prototype.first = function (func) {
        if (func === void 0) { func = null; }
        var items = this;
        if (func != null)
            items = this.filter(func);
        if (items.length > 1)
            return items[0];
        else
            throw new SequenceDoesNotContainException();
    };
}
if (!Array.prototype.firstOrDefault) {
    Array.prototype.firstOrDefault = function (func) {
        if (func === void 0) { func = null; }
        var items = this;
        if (func != null)
            items = this.filter(func);
        if (items.length > 0)
            return items[0];
        else
            return null;
    };
}
if (!Array.prototype.last) {
    Array.prototype.last = function (func) {
        if (func === void 0) { func = null; }
        var items = this.reverse();
        if (func != null)
            items = this.filter(func);
        items = this.filter(func);
        if (items.length > 1)
            return items[0];
        else
            throw new SequenceDoesNotContainException();
    };
}
if (!Array.prototype.lastOrDefault) {
    Array.prototype.lastOrDefault = function (func) {
        if (func === void 0) { func = null; }
        var items = this.reverse();
        if (func != null)
            items = this.filter(func);
        if (items.length > 0)
            return items[0];
        else
            return null;
    };
}
if (!Array.prototype.any) {
    Array.prototype.any = function (func) {
        if (func === void 0) { func = null; }
        var items = this;
        if (func != null)
            items = this.filter(func);
        return items.length > 0;
    };
}
if (!Array.prototype.all) {
    Array.prototype.all = function (func) {
        var items = this.filter(func);
        return items.length == this.length;
    };
}
var SequenceDoesNotContainException = (function (_super) {
    __extends(SequenceDoesNotContainException, _super);
    function SequenceDoesNotContainException() {
        var _this = _super.call(this) || this;
        Object.setPrototypeOf(_this, SequenceDoesNotContainException.prototype);
        return _this;
    }
    return SequenceDoesNotContainException;
}(Error));
var SequenceContainsMoreThanOneElementException = (function (_super) {
    __extends(SequenceContainsMoreThanOneElementException, _super);
    function SequenceContainsMoreThanOneElementException() {
        var _this = _super.call(this) || this;
        Object.setPrototypeOf(_this, SequenceContainsMoreThanOneElementException.prototype);
        return _this;
    }
    return SequenceContainsMoreThanOneElementException;
}(Error));
var ArrayExtensions = (function () {
    function ArrayExtensions() {
    }
    return ArrayExtensions;
}());
exports.ArrayExtensions = ArrayExtensions;

"use strict";
exports.__esModule = true;
if (!String.prototype.fromCamelCase) {
    String.prototype.fromCamelCase = function () {
        return this.replace(/([a-z](?=[A-Z]))/g, '$1 ');
    };
}
var StringExtensions = (function () {
    function StringExtensions() {
    }
    return StringExtensions;
}());
exports.StringExtensions = StringExtensions;

"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
var core_1 = require("@angular/core");
var LoaderComponent = (function () {
    function LoaderComponent(loaderService) {
        this.loaderService = loaderService;
        this.show = false;
    }
    LoaderComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.subscription = this.loaderService.loaderState
            .subscribe(function (state) {
            _this.show = state.show;
        });
    };
    LoaderComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    return LoaderComponent;
}());
LoaderComponent = __decorate([
    core_1.Component({
        selector: 'angular-loader',
        template: '<div [class.loader-hidden]="!show"><div class="loader-overlay"><div><md-progress-bar color="warn" mode="indeterminate" *ngIf="show"></md-progress-bar></div></div></div>',
        styleUrls: ['./loader.component.css'],
        moduleId: module.id
    })
], LoaderComponent);
exports.LoaderComponent = LoaderComponent;

"use strict";
exports.__esModule = true;

"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
var core_1 = require("@angular/core");
var Subject_1 = require("rxjs/Subject");
var LoaderService = (function () {
    function LoaderService() {
        this.loaderSubject = new Subject_1.Subject();
        this.loaderState = this.loaderSubject.asObservable();
    }
    LoaderService.prototype.show = function () {
        this.loaderSubject.next({ show: true });
    };
    LoaderService.prototype.hide = function () {
        this.loaderSubject.next({ show: false });
    };
    return LoaderService;
}());
LoaderService = __decorate([
    core_1.Injectable()
], LoaderService);
exports.LoaderService = LoaderService;
