"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var angular_2_local_storage_1 = require("angular-2-local-storage");
var index_1 = require("./index");
var InterceptedHttp = (function (_super) {
    __extends(InterceptedHttp, _super);
    function InterceptedHttp(backend, defaultOptions, localStorageService, loaderService) {
        var _this = _super.call(this, backend, defaultOptions) || this;
        _this.localStorageService = localStorageService;
        _this.loaderService = loaderService;
        return _this;
    }
    InterceptedHttp.prototype.get = function (url, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.get.call(this, url, this.getRequestOptionArgs(options))
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.post = function (url, body, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.post.call(this, url, body, this.getRequestOptionArgs(options))
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.put = function (url, body, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.put.call(this, url, body, this.getRequestOptionArgs(options))
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.delete = function (url, options) {
        var _this = this;
        this.showLoader();
        return _super.prototype.delete.call(this, url, this.getRequestOptionArgs(options))
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    InterceptedHttp.prototype.getRequestOptionArgs = function (options) {
        if (options == null) {
            options = new http_1.RequestOptions();
        }
        if (options.headers == null) {
            options.headers = new http_1.Headers();
        }
        options.headers.append('Content-Type', 'application/json');
        if (!options.withCredentials)
            this.createAuthorizationHeader(options.headers);
        return options;
    };
    InterceptedHttp.prototype.createAuthorizationHeader = function (headers) {
        if (this.localStorageService.get('id_token') != null) {
            headers.append('Authorization', this.localStorageService.get('id_token'));
        }
    };
    InterceptedHttp.prototype.onCatch = function (error) {
        //return Observable.throw(error);
        return error;
    };
    InterceptedHttp.prototype.onSuccess = function (res) {
        console.log('Request successful');
    };
    InterceptedHttp.prototype.onError = function (res) {
        console.log('Error, status code: ' + res.status);
    };
    InterceptedHttp.prototype.onEnd = function () {
        this.hideLoader();
    };
    InterceptedHttp.prototype.showLoader = function () {
        this.loaderService.show();
    };
    InterceptedHttp.prototype.hideLoader = function () {
        this.loaderService.hide();
    };
    return InterceptedHttp;
}(http_1.Http));
InterceptedHttp = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.ConnectionBackend, http_1.RequestOptions, angular_2_local_storage_1.LocalStorageService, index_1.LoaderService])
], InterceptedHttp);
exports.InterceptedHttp = InterceptedHttp;
//# sourceMappingURL=http.interceptor.js.map